package com.isu.gaswellwatch.modbus.data.decode.impl;

import com.isu.gaswellwatch.modbus.data.ModbusMessage;
import com.isu.gaswellwatch.modbus.data.decode.DecodeHandler;

import java.util.Collection;
import java.util.Map;

/**
 * @author <a href="mailto:scwsl@foxmail.com">王仕龙</a>
 * 2024/11/25 16:31
 */
public class ComposeDecodeHandler implements DecodeHandler {

    public final Collection<DecodeHandler> collection;

    public ComposeDecodeHandler(Collection<DecodeHandler> collection) {
        this.collection = collection;
    }

    @Override
    public String decode(Map<String, Object> commandPointMap, String value) {
        for (DecodeHandler handler : this.collection) {
            value = handler.decode(commandPointMap, value);
        }
        return value;
    }

    @Override
    public void decode(Map<String, Object> commandPointMap, ModbusMessage.MessagePoint point) {
        for (DecodeHandler handler : this.collection) {
            handler.decode(commandPointMap, point);
        }
    }
}
